use std::rc::Rc;

use engine::Engine;

const GAME_SIZE: (u32, u32) = (1200, 800);
const BORDER_WIDTH: u32 = 10;
const FG: u32 = 0xebdbb2;
const BG: u32 = 0x282828;

fn main() {
    let mut engine = Engine::new();
    // let _ = engine.insert_into_world(Rc::new(MovingRect::new(0, 0, 50, 100)));
    engine
        .set_resize_fn(|ctx, world, timer| {
            // top
            ctx.rect(0, 0, GAME_SIZE.0, BORDER_WIDTH, FG);
            // left
            ctx.rect(
                0,
                BORDER_WIDTH,
                BORDER_WIDTH,
                GAME_SIZE.1 - BORDER_WIDTH * 2,
                FG,
            );
            // right
            ctx.rect(
                GAME_SIZE.0 - BORDER_WIDTH,
                BORDER_WIDTH,
                BORDER_WIDTH,
                GAME_SIZE.1 - BORDER_WIDTH * 2,
                FG,
            );
            // bottom
            ctx.rect(0, GAME_SIZE.1 - BORDER_WIDTH, GAME_SIZE.0, 10, FG);
        })
        .set_render_fn(|ctx, world, timer| {
            // println!("t: {}", timer.game_time_passed());
            // let obj = Rc::get_mut(world.get_mut(0)).unwrap();
            // obj.move_obj(1, 0);
            // obj.draw_move(ctx)
            // Rect::square((timer.game_time_passed() * 20.) as u32, 0, 200).display(ctx);
        })
        .run();
}

mod engine;
